*>----------------------------------------------------+
*> COPYRIGHT(2017,2018) BY VEIT HEISE, PQM-CONSULTING |
*> ALL RIGHTS RESERVED BY THE AUTHOR                  |
*> THIS IS RECOMMENDED FOR THE USAGE OF THIS SOFTWARE |
*> INSIDE COMMERCIAL PRODUCT. USING FOR COMMERCIAL    |
*> PRODUCTS WITHOUT PERMISSION BY THE AUTHOR IS       |
*> LEGALLY PROHIBITTED.                               |
*>----------------------------------------------------+
IDENTIFICATION DIVISION.
PROGRAM-ID. AHF001.
*>-----------------------------------------------------------------+
*> B101        -  [ INIT PROGRAM ]                                 |
*>-----------------------------------------------------------------+
*> B301        -  [ INIT ZEILE WSDA-TABLE ]                        |
*> B302        -  [ INIT WSDA-TABLE WITH DATA FROM WP_ARTIKEL ]    |
*>-----------------------------------------------------------------+
*> B303        -  [ INIT HEADER SCREEN-01 ]                        |
*>-----------------------------------------------------------------+
*> B801        -  [ IN-OUTPUT SCREEN-01 : PREIS-LISTE ]            |
*> PD200-SD200 -  TRANSFER FROM FILE WP-ARTIKEL TO WSD-200-RECORD  |
*> SD200-PD200 -  TRANSFER FROM WSD-200-RECORD TO WP-ARTIKEL       |
*>-----------------------------------------------------------------+
*> DECLARATIVES WP-ARTIKEL                                         |
*>-----------------------------------------------------------------+
ENVIRONMENT DIVISION.
CONFIGURATION SECTION.
SOURCE-COMPUTER.    HP-PRO-BOOK-650G.
OBJECT-COMPUTER.    UBUNTU-64-BIT.
SPECIAL-NAMES.
*>   CURSOR IS COB-CURSOR,
*>   CRT STATUS IS COB-CRT-STATUS,
   DECIMAL-POINT IS COMMA.
   REPOSITORY.
      FUNCTION ALL INTRINSIC.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
   COPY "sd-wp-artikel".
I-O-CONTROL.
DATA DIVISION.
FILE SECTION.
   COPY "fd-wp-artikel".
WORKING-STORAGE SECTION.
*>---------------------------------------------------------------+
   COPY "global".
*>---------------------------------------------------------------+
01 WPD200-STATUS                       PIC 99.
*>---------------------------------------------------------------+
01 WSD200-RECORD.
   03 WSD200-KEY.
      05 WSD200-ID                     PIC 9(12).
   03 WSD200-ALTERNATE-1.
      05 WSD200-SOUNDEX                PIC X(20).
   03 WSD200-DATA.
      05 WSD200-BEZEICHNUNG            PIC X(40).
      05 WSD200-BESTAND                PIC 9(12).
      05 WSD200-MIN-BESTAND            PIC 9(12).
      05 WSD200-BESTELL-MENGE          PIC 9(12).
      05 WSD200-MENGEN-EINH            PIC X(10).
      05 WSD200-PREIS                  PIC 9(9)V99 COMP-3.
      05 WSD200-WARENWERT              PIC 9(9)V99 COMP-3.
      05 WSD200-USTPROZ                PIC 9(3)V99 COMP-3.
      05 WSD200-MENGE-JAHR             PIC 9(12).
      05 WSD200-MENGE-VORJAHR          PIC 9(12).
      05 WSD200-UMSATZ-JAHR            PIC 9(9)V99 COMP-3.
      05 WSD200-UMSATZ-VORJAHR         PIC 9(9)V99 COMP-3.
      05 WSD200-DELETE                 PIC X.
*>---------------------------------------------------------------+
*> WP_ARTIKEL: LISTE PREISE                                      |
*>---------------------------------------------------------------+
01 ZEILE                               PIC 99.
01 WSDA-TABLE.
   03 WSDA-LINE OCCURS 30 TIMES.
      05 WSDA-CMD                      PIC X.
      05 WSDA-ID                       PIC 9(12).
      05 WSDA-BEZEICHNUNG              PIC X(40).
      05 WSDA-BESTAND                  PIC 9(12).
      05 WSDA-PREIS                    PIC 9(9)V99 COMP-3.
*>---------------------------------------------------------------+
*>---------------------------------------------------------------+
SCREEN SECTION.
*>---------------------------------------------------------------+
*> SCREEN-01 : PREISLISTE                                        |
*>---------------------------------------------------------------+
01 SCREEN-01.
   COPY "screen/screen-01".
*>---------------------------------------------------------------+
*>---------------------------------------------------------------+
*> SCREEN HEADER                                                 |
*>---------------------------------------------------------------+
   COPY "standard-header".
*>---------------------------------------------------------------+
*>---------------------------------------------------------------+
*>---------------------------------------------------------------+
*> SCREEN STANDARD-ERROR                                         |
*>---------------------------------------------------------------+
*>
PROCEDURE DIVISION.
DECLARATIVES.
*>
*>-----------------------------------------------------------------+
*> DECLARATIVES WP-ARTIKEL                                         |
*>-----------------------------------------------------------------+
*>
WP-ARTIKEL-HANDLER SECTION.
   USE AFTER STANDARD ERROR PROCEDURE ON WP-ARTIKEL.
WP-ARTIKEL-ERROR.
   EVALUATE WPD200-STATUS
      WHEN 35 PERFORM
                 OPEN OUTPUT WP-ARTIKEL
                 CLOSE WP-ARTIKEL
                 OPEN I-O WP-ARTIKEL
              END-PERFORM
      WHEN OTHER PERFORM
               DISPLAY "Error " WPD200-STATUS " on file WP-ARTIKEL" UPON SYSERR
               CLOSE WP-ARTIKEL
               GOBACK
              END-PERFORM
   END-EVALUATE.
*>
END DECLARATIVES.
*>
*>---------------------------------------------------------------+
*> P R O G R A M M   S T A R T E T   H I E R                     |
*>---------------------------------------------------------------+
PROGRAM-START.
   PERFORM B101 THRU B101-XXX. *> [ INIT PROGRAM ]
   GOBACK.
*>
*>-----------------------------------------------------------------+
*> B101        -  [ INIT PROGRAM ]                                 |
*>-----------------------------------------------------------------+
B101.
   PERFORM WITH TEST BEFORE VARYING ZEILE FROM 1 BY 1 UNTIL ZEILE > 30
      PERFORM B301 THRU B301-XXX *> [ INIT ZEILE WSDA-TABLE ]
   END-PERFORM.
   PERFORM B302 THRU B302-XXX. *> [ INIT WSDA-TABLE WITH DATA FROM WP_ARTIKEL ]
   PERFORM B801 THRU B801-XXX. *>[ IN-OUTPUT SCREEN-01 : PREIS-LISTE ]
B101-XXX.
*>-----------------------------------------------------------------+
*> B301        -  [ INIT ZEILE WSDA-TABLE ]                        |
*>-----------------------------------------------------------------+
B301.
   MOVE ZEROS TO WSDA-ID(ZEILE), WSDA-BESTAND(ZEILE), WSDA-PREIS(ZEILE).
   MOVE SPACE TO WSDA-CMD(ZEILE).
   MOVE SPACES TO WSDA-BEZEICHNUNG(ZEILE).
B301-XXX.
*>
*>-----------------------------------------------------------------+
*> B302        -  [ INIT WSDA-TABLE WITH DATA FROM WP_ARTIKEL ]    |
*>-----------------------------------------------------------------+
B302.
   OPEN INPUT WP-ARTIKEL.
   MOVE SPACES TO WPD200-ALTERNATE-1.
   START WP-ARTIKEL KEY > WPD200-ALTERNATE-1
      INVALID KEY GO TO B302-90
   END-START.
   MOVE 1 TO ZEILE.
B302-10.
   READ WP-ARTIKEL NEXT RECORD AT END GO TO B302-90.
   PERFORM PD200-SD200 THRU PD200-SD200-XXX.
   MOVE WSD200-ID          TO WSDA-ID(ZEILE).
   MOVE WSD200-BEZEICHNUNG TO WSDA-BEZEICHNUNG(ZEILE).
   MOVE WSD200-BESTAND     TO WSDA-BESTAND(ZEILE).
   MOVE WSD200-PREIS       TO WSDA-PREIS(ZEILE).
   ADD 1 TO ZEILE.
   IF ZEILE < 31 THEN GO TO B302-10.
B302-90.
   CLOSE WP-ARTIKEL.
B302-XXX.
*>
*>-----------------------------------------------------------------+
*> B303        -  [ INIT HEADER SCREEN-01 ]                        |
*>-----------------------------------------------------------------+
B303.
   MOVE "screen-01" TO ZZ-SCREEN.
   MOVE "A R T I K E L - S T A M M D A T E N :   P R E I S E" TO ZZ-HEADER.
   PERFORM DSP-STANDARD-HEADER THRU DSP-STANDARD-HEADER-XXX.
B303-XXX.
*>
*>
*>-----------------------------------------------------------------+
*> B801        -  [ IN-OUTPUT SCREEN-01 : PREIS-LISTE ]            |
*>-----------------------------------------------------------------+
B801.
   PERFORM B303 THRU B303-XXX. *> [ INIT HEADER SCREEN-01 ]
   DISPLAY SCREEN-01.
   ACCEPT  SCREEN-01.
B801-XXX.
*>
*>---------------------------------------------------------------+
*> TRANSFER FROM FILE WP-ARTIKEL TO WSD-200-RECORD.              |
*>---------------------------------------------------------------+
PD200-SD200.
   MOVE WPD200-BEZEICHNUNG TO ZZ-SOUND1.
   CALL "SOUNDEX" USING ZZ-SOUND1, WPD200-SOUNDEX.
   MOVE WPD200-RECORD TO WSD200-RECORD.
PD200-SD200-XXX.
*>
*>---------------------------------------------------------------+
*> TRANSFER FROM WSD-200-RECORD TO WP-ARTIKEL.                   |
*>---------------------------------------------------------------+
SD200-PD200.
   MOVE WSD200-BEZEICHNUNG TO ZZ-SOUND1.
   CALL "SOUNDEX" USING ZZ-SOUND1, WSD200-SOUNDEX.
   MOVE WSD200-RECORD TO WPD200-RECORD.
SD200-PD200-XXX.
*>
*>---------------------------------------------------------------+
*> DISPLAY STANDARD-HEADER                                       |
*>---------------------------------------------------------------+
DSP-STANDARD-HEADER.
   ACCEPT ZZ-TOTAL-LINES FROM LINES.
   ACCEPT ZZ-TOTAL-COLUMNS FROM COLUMNS.
   COMPUTE ZZ-INT1 = ZZ-TOTAL-COLUMNS / 2.
   COMPUTE ZZ-INT2 = STORED-CHAR-LENGTH(ZZ-HEADER) / 2.
   COMPUTE ZZ-XCOL = ZZ-INT1 - ZZ-INT2 + 1.
   ACCEPT COB-DATE FROM DATE YYYYMMDD.
   ACCEPT COB-TIME FROM TIME.
   DISPLAY STANDARD-HEADER.
DSP-STANDARD-HEADER-XXX.
*>---------------------------------------------------------------+
END PROGRAM AHF001.
*>---------------------------------------------------------------+
*>
*> DO NOT ADD CODE HERE!
*>
*>
*>
*>
*>
*>
*>
