*>----------------------------------------------------+
*> COPYRIGHT(2017,2018) BY VEIT HEISE, PQM-CONSULTING |
*> ALL RIGHTS RESERVED BY THE AUTHOR                  |
*> THIS IS RECOMMENDED FOR THE USAGE OF THIS SOFTWARE |
*> INSIDE COMMERCIAL PRODUCT. USING FOR COMMERCIAL    |
*> PRODUCTS WITHOUT PERMISSION BY THE AUTHOR IS       |
*> LEGALLY PROHIBITTED.                               |
*>----------------------------------------------------+
IDENTIFICATION DIVISION.
PROGRAM-ID. ZZ-STD-ERR.
*>---------------------------------------------------------------+
*> ««« STANDARD ERROR HANDLER »»»                                |
*>---------------------------------------------------------------+
ENVIRONMENT DIVISION.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
I-O-CONTROL.
DATA DIVISION.
FILE SECTION.
WORKING-STORAGE SECTION.
01  BUFFER                             PIC X(255).
01  POS                                PIC 999.
01  SLINES                             PIC 999.
01  ANSWER                             PIC X.
*>---------------------------------------------------------------+
    COPY "global".
*>---------------------------------------------------------------+
LINKAGE SECTION.
01  YY-ERROR                           PIC 99.
01  YY-MESSAGE                         PIC X(80).
01  YY-ERRFILE                         PIC X(20).
01  YY-PROGRAM                         PIC X(20).
SCREEN SECTION.
*>---------------------------------------------------------------+
*> SCREEN HEADER                                                 |
*>---------------------------------------------------------------+
*> SCREEN STANDARD-ERROR                                         |
*>---------------------------------------------------------------+
01  STD-ERROR.
    03 LINE SLINES COL 1 ERASE EOL
       COPY "color-error".
    01 PIC X(128) FROM BUFFER
       COPY "color-error".
    01 VALUE " : ".
    01 PIC X USING ANSWER
       COPY "color-using".
*>---------------------------------------------------------------+
PROCEDURE DIVISION USING YY-ERROR, YY-MESSAGE.
*>---------------------------------------------------------------+
*> P R O G R A M M   S T A R T E T   H I E R                     |
*>---------------------------------------------------------------+
PROGRAM-START.
    EVALUATE YY-ERROR
      WHEN 00 MOVE "SUCCESS"                           TO YY-MESSAGE
      WHEN 02 MOVE "SUCCESS DUPLICATE"                 TO YY-MESSAGE
      WHEN 04 MOVE "SUCCESS INCOMPLETE"                TO YY-MESSAGE
      WHEN 05 MOVE "SUCCESS OPTIONAL"                  TO YY-MESSAGE
      WHEN 07 MOVE "SUCCESS NO UNIT"                   TO YY-MESSAGE
      WHEN 10 MOVE "END OF FILE"                       TO YY-MESSAGE
      WHEN 14 MOVE "OUT OF KEY RANGE"                  TO YY-MESSAGE
      WHEN 21 MOVE "KEY INVALID"                       TO YY-MESSAGE
      WHEN 22 MOVE "KEY EXISTS"                        TO YY-MESSAGE
      WHEN 23 MOVE "KEY NOT EXISTS"                    TO YY-MESSAGE
      WHEN 30 MOVE "PERMANENT ERROR"                   TO YY-MESSAGE
      WHEN 31 MOVE "INCONSISTENT FILENAME"             TO YY-MESSAGE
      WHEN 34 MOVE "BOUNDARY VIOLATION"                TO YY-MESSAGE
      WHEN 35 MOVE "FILE NOT FOUND"                    TO YY-MESSAGE
      WHEN 37 MOVE "PERMISSION DENIED"                 TO YY-MESSAGE
      WHEN 38 MOVE "CLOSED WITH LOCK"                  TO YY-MESSAGE
      WHEN 39 MOVE "CONFLICT ATTRIBUTE"                TO YY-MESSAGE
      WHEN 41 MOVE "ALREADY OPEN"                      TO YY-MESSAGE
      WHEN 42 MOVE "NOT OPEN"                          TO YY-MESSAGE
      WHEN 43 MOVE "READ NOT DONE"                     TO YY-MESSAGE
      WHEN 44 MOVE "RECORD OVERFLOW"                   TO YY-MESSAGE
      WHEN 46 MOVE "READ ERROR"                        TO YY-MESSAGE
      WHEN 47 MOVE "INPUT DENIED"                      TO YY-MESSAGE
      WHEN 48 MOVE "OUTPUT DENIED"                     TO YY-MESSAGE
      WHEN 49 MOVE "I/O DENIED"                        TO YY-MESSAGE
      WHEN 51 MOVE "RECORD LOCKED"                     TO YY-MESSAGE
      WHEN 52 MOVE "END-OF-PAGE"                       TO YY-MESSAGE
      WHEN 57 MOVE "I/O LINAGE"                        TO YY-MESSAGE
      WHEN 61 MOVE "FILE SHARING FAILURE"              TO YY-MESSAGE
      WHEN 91 MOVE "FILE NOT AVAILABLE"                TO YY-MESSAGE
      WHEN OTHER MOVE "UNKNOWN ERROR"                  TO YY-MESSAGE
    END-EVALUATE.
    GOBACK.
ENTRY "ZZ-STD-ERRMSG" USING YY-ERROR, YY-ERRFILE, YY-PROGRAM, YY-MESSAGE.
    CALL "ZZ-STR-ERR" USING YY-ERROR, YY-MESSAGE.
    MOVE YY-PROGRAM TO BUFFER.
    COMPUTE POS = STORED-CHAR-LENGTH(BUFFER) + 1.
    MOVE ":" TO BUFFER(POS:).
    COMPUTE POS = STORED-CHAR-LENGTH(BUFFER) + 2.
    MOVE "ERROR" TO BUFFER(POS:).
    COMPUTE POS = STORED-CHAR-LENGTH(BUFFER) + 2.
    MOVE YY-ERROR TO BUFFER(POS:).
    COMPUTE POS = STORED-CHAR-LENGTH(BUFFER) + 1.
    MOVE ":" TO BUFFER(POS:).
    COMPUTE POS = STORED-CHAR-LENGTH(BUFFER) + 2.
    MOVE YY-MESSAGE TO BUFFER(POS:).
    ACCEPT SLINES FROM LINES.
    DISPLAY STD-ERROR.
    ACCEPT  STD-ERROR.
    GOBACK.
*>
END PROGRAM ZZ-STD-ERR.
*>
*> DO NOT ADD CODE HERE!
*>
