*>----------------------------------------------------+
*> COPYRIGHT(2017,2018) BY VEIT HEISE, PQM-CONSULTING |
*> ALL RIGHTS RESERVED BY THE AUTHOR                  |
*> THIS IS RECOMMENDED FOR THE USAGE OF THIS SOFTWARE |
*> INSIDE COMMERCIAL PRODUCT. USING FOR COMMERCIAL    |
*> PRODUCTS WITHOUT PERMISSION BY THE AUTHOR IS       |
*> LEGALLY PROHIBITTED.                               |
*>----------------------------------------------------+
>>SOURCE FORMAT FREE
IDENTIFICATION DIVISION.
PROGRAM-ID. UPPER.
*>---------------------------------------------------------------+
*> P R O G R A M - N A M E                                       |
*>---------------------------------------------------------------+
*> B101 =   INITIALISIERT DIE PROGRAMM-PARAMETER                 |
*>---------------------------------------------------------------+
*>---------------------------------------------------------------+
*>---------------------------------------------------------------+
ENVIRONMENT DIVISION.
CONFIGURATION SECTION.
SOURCE-COMPUTER.    HP-PRO-BOOK-650G.
OBJECT-COMPUTER.    UBUNTU-64-BIT.
SPECIAL-NAMES.
CURSOR IS COB-CURSOR,
CRT STATUS IS COB-CRT-STATUS,
DECIMAL-POINT IS COMMA.
REPOSITORY.
FUNCTION ALL INTRINSIC.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
*>---------------------------------------------------------------+
*> FILE1 = INPUT-FILE                                            |
*>---------------------------------------------------------------+
    SELECT FILE1 ASSIGN TO FILE1-NAME
    FILE STATUS FILE1-ERROR
    ORGANIZATION IS LINE SEQUENTIAL
    ACCESS MODE IS SEQUENTIAL.
*>---------------------------------------------------------------+
*> FILE2 = OUTPUT-FILE                                           |
*>---------------------------------------------------------------+
    SELECT FILE2 ASSIGN TO FILE2-NAME
    FILE STATUS FILE2-ERROR
    ORGANIZATION IS LINE SEQUENTIAL
    ACCESS MODE IS SEQUENTIAL.
I-O-CONTROL.
DATA DIVISION.
FILE SECTION.
*>---------------------------------------------------------------+
*> FILE1 = INPUT-FILE                                            |
*>---------------------------------------------------------------+
FD  FILE1.
01  FILE1-RECORD.
    03  FILE1-LINE OCCURS 256.
        05  FILE1-CHAR                  PIC X.
*>---------------------------------------------------------------+
*> FILE2 = OUTPUT-FILE                                           |
*>---------------------------------------------------------------+
FD  FILE2.
01  FILE2-RECORD.
    03  FILE2-LINE OCCURS 256.
        05  FILE2-CHAR                  PIC X.
WORKING-STORAGE SECTION.
    COPY "global".
01  ARGS-NUM                            PIC 9.
01  ARGS-TXT                            PIC X(100).
*>---------------------------------------------------------------+
*> FILE1 = INPUT-FILE                                            |
*>---------------------------------------------------------------+
01  FILE1-ERROR                         PIC 99.
01  FILE1-NAME                          PIC X(100).
01  FILE1-BUF                           PIC X(512).
*>---------------------------------------------------------------+
*> FILE2 = OUTPUT-FILE                                           |
*>---------------------------------------------------------------+
01  FILE2-ERROR                         PIC 99.
01  FILE2-NAME                          PIC X(100).
*>---------------------------------------------------------------+
01  MASK1                               PIC 9.
01  MASK2                               PIC 9.
01  HAT1                                PIC 9.
01  HAT2                                PIC 9.
01  MASK                                PIC X.
*>---------------------------------------------------------------+

SCREEN SECTION.
PROCEDURE DIVISION.
*>---------------------------------------------------------------+
*> D E C L A R A T I V E S                                       |
*>---------------------------------------------------------------+
DECLARATIVES.
END DECLARATIVES.
PROGRAM-START.
    MOVE "/home/heise/temp/upper.txt" TO FILE2-NAME.
    PERFORM B101 THRU B101-EXIT. *> [ INITIALISIERT DIE PROGRAMM-PARAMETER ]
    PERFORM B201 THRU B201-EXIT. *> [ FOLD UPPER-CASE ]
    CLOSE FILE1.
    CLOSE FILE2.
    CALL "CBL_COPY_FILE" USING FILE2-NAME, FILE1-NAME.
    CALL "CBL_DELETE_FILE" USING FILE2-NAME.
    GOBACK.
*>---------------------------------------------------------------+
*> B101 =   INITIALISIERT DIE PROGRAMM-PARAMETER                 |
*>---------------------------------------------------------------+
B101.
    ACCEPT ARGS-NUM FROM ARGUMENT-NUMBER.
    IF ARGS-NUM NOT = 1 THEN
        DISPLAY "upper:(Stop) invalid argument number, have to be one!" UPON SYSERR
        GOBACK
    END-IF.
    DISPLAY 1 UPON ARGUMENT-NUMBER.
    ACCEPT ZZ-FILENAME FROM ARGUMENT-VALUE.
    COMPUTE ZZ-POS = STORED-CHAR-LENGTH(ZZ-FILENAME) + 1.
    MOVE ZZ-FILENAME TO ARGS-TXT.
    MOVE ".cob" TO ARGS-TXT(ZZ-POS:).
    MOVE ARGS-TXT TO FILE1-NAME.
    COMPUTE ZZ-POS = STORED-CHAR-LENGTH(FILE1-NAME).
    OPEN INPUT FILE1.
    IF FILE1-ERROR NOT = 0 THEN
      GO TO B101-10
    ELSE
      GO TO B101-900
    END-IF.
B101-10.
    MOVE ZZ-FILENAME TO ARGS-TXT.
    MOVE ".cpy" TO ARGS-TXT(ZZ-POS:).
    MOVE ARGS-TXT TO FILE1-NAME.
    COMPUTE ZZ-POS = STORED-CHAR-LENGTH(FILE1-NAME).
    OPEN INPUT FILE1.
    IF FILE1-ERROR NOT = 0 THEN
      GO TO B101-20
    ELSE
      GO TO B101-900
    END-IF.
B101-20.
    MOVE ZZ-FILENAME TO FILE1-NAME.
    OPEN INPUT FILE1.
    IF NOT FILE1-ERROR = 0 THEN
      DISPLAY "File '"  FILE1-NAME  "' not found." UPON SYSERR
      GOBACK
    END-IF.
B101-900.
    COMPUTE ZZ-POS = STORED-CHAR-LENGTH(FILE2-NAME).
    OPEN OUTPUT FILE2.
    IF FILE2-ERROR NOT = 0 THEN
      DISPLAY "Error: '" FILE2-NAME(1:ZZ-POS) "' not found."
      GOBACK
    END-IF.
B101-EXIT.
*>---------------------------------------------------------------+
B201.
   MOVE 0 TO MASK1 MASK2.
   MOVE SPACES TO FILE2-RECORD.
B201-10.
   READ FILE1 NEXT RECORD AT END GO TO B201-EXIT.
   COMPUTE ZZ-POS = STORED-CHAR-LENGTH(FILE1-RECORD).
   IF ZZ-POS = 0 THEN
      WRITE FILE2-RECORD
      GO TO B201-10
   END-IF.
   COMPUTE ZZ-INT1 = STORED-CHAR-LENGTH(FILE1-RECORD).
   PERFORM WITH TEST BEFORE VARYING ZZ-POS FROM 1 BY 1 UNTIL ZZ-POS > ZZ-INT1
      MOVE FILE1-CHAR(ZZ-POS) TO MASK
      IF (HAT1 = 0) AND (HAT2 = 0) THEN
         IF MASK = "'" THEN
            MOVE 1 TO MASK1 HAT1
            MOVE MASK TO FILE2-CHAR(ZZ-POS)
         ELSE
            IF MASK = '"' THEN
               MOVE 1 TO MASK2 HAT2
               MOVE MASK TO FILE2-CHAR(ZZ-POS)
            ELSE
               MOVE UPPER-CASE(MASK) TO FILE2-CHAR(ZZ-POS)
            END-IF
         END-IF
      ELSE
         IF (HAT1 = 1) AND (HAT2 = 0) THEN
            IF MASK = "'" THEN
               MOVE 0 TO HAT1
            END-IF
         END-IF
         IF (HAT2 = 1) AND (HAT1 = 0) THEN
            IF MASK = '"' THEN
               MOVE 0 TO HAT2
            END-IF
         END-IF
         MOVE MASK TO FILE2-CHAR(ZZ-POS)
      END-IF
   END-PERFORM.
   WRITE FILE2-RECORD.
   MOVE SPACES TO FILE2-RECORD.
   GO TO B201-10.
B201-EXIT.
*>---------------------------------------------------------------+
*> ZZ-ERROR-ANALYZE                                              |
*>---------------------------------------------------------------+
*>    COPY "error-handler".
*>---------------------------------------------------------------+
*>                                                               |
*> DO NOT ENTER ANY CODE BEHIND HERE!                            |
*>                                                               |
*>                                                               |
*>                                                               |
*>                                                               |
*>                                                               |
*>---------------------------------------------------------------+
